#include "../stm32wrapper.h"
#include <stdio.h>

extern void chacha_perm_asm(unsigned char* out, const unsigned char* in);

int main(void)
{
    clock_setup();
    gpio_setup();
    usart_setup(921600);

    unsigned char data[64];
    unsigned char digest[64];
    unsigned char output[128];
    int i;

    SCS_DEMCR |= SCS_DEMCR_TRCENA;
    DWT_CYCCNT = 0;
    DWT_CTRL |= DWT_CTRL_CYCCNTENA;

    for(i=0; i<64; i++) data[i] = i;

    unsigned int oldcount = DWT_CYCCNT;
    chacha_perm_asm(digest, data);
    unsigned int newcount = DWT_CYCCNT-oldcount;

    for(i=0; i < 64; i++) {
       sprintf(output + 2*i, "%02X", digest[i]); 
    }
    send_USART_bytes(output, 128);

    sprintf(output, "Cost: %d", newcount);
    send_USART_str(output);

    while(1);
    return 0;
}
