#include "../crypto_sign.h"
#include "../api.h"
#include "../stm32wrapper.h"
#include <stdio.h>

int main(void)
{
    int i;
    unsigned char output[128];
    unsigned char sphincs_sk[CRYPTO_SECRETKEYBYTES];

    clock_setup();
    gpio_setup();
    usart_setup(921600);
    dma_request_setup();
    dma_transmit_setup();

    for(i=0; i<CRYPTO_SECRETKEYBYTES; i++) sphincs_sk[i] = 12;

    SCS_DEMCR |= SCS_DEMCR_TRCENA;
    DWT_CYCCNT = 0;
    DWT_CTRL |= DWT_CTRL_CYCCNTENA;

    unsigned int oldcount = DWT_CYCCNT;
    crypto_sign(sphincs_sk); // input processing is done internally
    unsigned int newcount = DWT_CYCCNT-oldcount;

    sprintf(output, "Cost: %d", newcount);
    send_USART_str(output);

    while(1);
    return 0;
}