#include "../crypto_sign.h"
#include "../api.h"
#include "../stm32wrapper.h"
#include <stdio.h>

#define MAXSTACK 9000 // gradually lower this as stack usage is optimized
#define CANARY 42

volatile unsigned char *p;

static unsigned int stack_count(volatile unsigned char *a)
{
    volatile unsigned char *p = (a-MAXSTACK);
    unsigned int c = 0;
    while(*p == CANARY && p < a)
    {
        p++;
        c++;
    }
    return c;
} 

#define WRITE_CANARY(X) {p=X;while(p>= (X-MAXSTACK)) *(p--) = CANARY;}

int main(void)
{
	int i;
    volatile unsigned char output[60];
	unsigned char sphincs_sk[CRYPTO_SECRETKEYBYTES];

	clock_setup();
	gpio_setup();
	usart_setup(921600);
	dma_request_setup();
	dma_transmit_setup();
    unsigned int ctr;
    volatile unsigned char a; /* Mark the beginning of the stack */

	for(i=0; i<CRYPTO_SECRETKEYBYTES; i++) sphincs_sk[i] = 12;

    WRITE_CANARY(&a);
	int x = crypto_sign(sphincs_sk); // input processing is done internally
    ctr = MAXSTACK - stack_count(&a);

    sprintf(output, "Result: %d", x);
    send_USART_str(output);
    sprintf(output, "Cost: %d", ctr);
    send_USART_str(output);

	while(1);

	return 0;
}
