#include "crypto_sign.h"
#include "api.h"
#include "stm32wrapper.h"
#include <stdio.h>

#define MLEN 32

int main(void)
{
    unsigned char sphincs_key[CRYPTO_SECRETKEYBYTES]; // first used for sk, then for pk
    unsigned char sphincs_m[MLEN];
    unsigned long long sphincs_mlen;
    int i;

    clock_setup();
    gpio_setup();
    usart_setup(921600);
    dma_request_setup();

    for(i=0; i<CRYPTO_SECRETKEYBYTES; i++) sphincs_key[i] = 12; // placeholder value
    crypto_sign_public_key(sphincs_key, sphincs_key);

    unsigned char x = (unsigned char)crypto_sign_open(sphincs_m, &sphincs_mlen, 41000 + MLEN, sphincs_key);
    send_USART_bytes(&x, 1);

    while(1);

    return 0;
}
